blob: 260a65a056f8896c815827f2ac3da200b8cf94af [file] [log] [blame]
jeffhao5d1ac922011-09-29 17:41:15 -07001#!/bin/bash
2#
3# Copyright (C) 2007 The Android Open Source Project
4#
5# Licensed under the Apache License, Version 2.0 (the "License");
6# you may not use this file except in compliance with the License.
7# You may obtain a copy of the License at
8#
9# http://www.apache.org/licenses/LICENSE-2.0
10#
11# Unless required by applicable law or agreed to in writing, software
12# distributed under the License is distributed on an "AS IS" BASIS,
13# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
14# See the License for the specific language governing permissions and
15# limitations under the License.
16
17# Set up prog to be the path of this script, including following symlinks,
18# and set up progdir to be the fully-qualified pathname of its directory.
19prog="$0"
Andreas Gampedeb48a02014-10-22 00:44:35 -070020args="$@"
jeffhao5d1ac922011-09-29 17:41:15 -070021while [ -h "${prog}" ]; do
22 newProg=`/bin/ls -ld "${prog}"`
23 newProg=`expr "${newProg}" : ".* -> \(.*\)$"`
24 if expr "x${newProg}" : 'x/' >/dev/null; then
25 prog="${newProg}"
26 else
27 progdir=`dirname "${prog}"`
28 prog="${progdir}/${newProg}"
29 fi
30done
31oldwd=`pwd`
32progdir=`dirname "${prog}"`
33cd "${progdir}"
34progdir=`pwd`
35prog="${progdir}"/`basename "${prog}"`
Brian Carlstrom105215d2012-06-14 12:50:44 -070036test_dir="test-$$"
Andreas Gampe5a79fde2014-08-06 13:12:26 -070037if [ -z "$TMPDIR" ]; then
38 tmp_dir="/tmp/$USER/${test_dir}"
39else
Andreas Gampe34a8a0f2016-07-20 21:09:29 -070040 tmp_dir="${TMPDIR}/${test_dir}"
Andreas Gampe5a79fde2014-08-06 13:12:26 -070041fi
David Brazdil2c27f2c2015-05-12 18:06:38 +010042checker="${progdir}/../tools/checker/checker.py"
jeffhao5d1ac922011-09-29 17:41:15 -070043export JAVA="java"
Alex Lightea1e7702016-07-11 13:39:55 -070044export JAVAC="javac -g -Xlint:-options"
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +010045export RUN="${progdir}/etc/run-test-jar"
Brian Carlstrom105215d2012-06-14 12:50:44 -070046export DEX_LOCATION=/data/run-test/${test_dir}
Elliott Hughesc717eef2012-06-15 16:01:26 -070047export NEED_DEX="true"
Alan Leung0afa07a2017-10-03 16:56:30 -070048export USE_D8="false"
Colin Crosse0ef0a82017-07-27 21:29:18 +000049export USE_JACK="false"
Igor Murashkin2a337752017-06-16 14:34:40 +000050export USE_DESUGAR="true"
Ben Gruver14fc9db2017-04-28 15:30:49 -070051export SMALI_ARGS=""
jeffhao5d1ac922011-09-29 17:41:15 -070052
Tsu Chiang Chuang4407e612012-07-19 16:13:43 -070053# If dx was not set by the environment variable, assume it is in the path.
54if [ -z "$DX" ]; then
55 export DX="dx"
56fi
57
Tsu Chiang Chuang6674f8a2013-01-16 15:41:21 -080058# If jasmin was not set by the environment variable, assume it is in the path.
59if [ -z "$JASMIN" ]; then
60 export JASMIN="jasmin"
61fi
62
Andreas Gampe8fda9f22014-10-03 16:15:37 -070063# If smali was not set by the environment variable, assume it is in the path.
64if [ -z "$SMALI" ]; then
65 export SMALI="smali"
66fi
67
68# If dexmerger was not set by the environment variable, assume it is in the path.
69if [ -z "$DXMERGER" ]; then
70 export DXMERGER="dexmerger"
71fi
72
Sebastien Hertz19ac0272015-02-24 17:39:50 +010073# If jack was not set by the environment variable, assume it is in the path.
74if [ -z "$JACK" ]; then
75 export JACK="jack"
76fi
77
Sebastien Hertz19ac0272015-02-24 17:39:50 +010078# ANDROID_BUILD_TOP is not set in a build environment.
79if [ -z "$ANDROID_BUILD_TOP" ]; then
80 export ANDROID_BUILD_TOP=$oldwd
81fi
82
Andreas Gampef47fb2f2016-06-24 22:30:29 -070083# ANDROID_HOST_OUT is not set in a build environment.
84if [ -z "$ANDROID_HOST_OUT" ]; then
Dan Willemsenf325e012017-03-03 12:35:30 -080085 export ANDROID_HOST_OUT=${OUT_DIR:-$ANDROID_BUILD_TOP/out}/host/linux-x86
Andreas Gampef47fb2f2016-06-24 22:30:29 -070086fi
87
Sebastien Hertz19ac0272015-02-24 17:39:50 +010088# If JACK_CLASSPATH is not set, assume it only contains core-libart.
89if [ -z "$JACK_CLASSPATH" ]; then
Andreas Gampef47fb2f2016-06-24 22:30:29 -070090 export JACK_CLASSPATH="${ANDROID_HOST_OUT}/../common/obj/JAVA_LIBRARIES/core-libart-hostdex_intermediates/classes.jack:${ANDROID_HOST_OUT}/../common/obj/JAVA_LIBRARIES/core-oj-hostdex_intermediates/classes.jack"
Sebastien Hertz19ac0272015-02-24 17:39:50 +010091fi
92
Sebastien Hertz19ac0272015-02-24 17:39:50 +010093export JACK="$JACK -g -cp $JACK_CLASSPATH"
Tsu Chiang Chuang6674f8a2013-01-16 15:41:21 -080094
Igor Murashkine5181932017-06-15 16:03:50 -070095# Allow changing DESUGAR script to something else, or to disable it with DESUGAR=false.
Igor Murashkind3232772017-06-22 14:54:13 -070096if [ -z "$DESUGAR" ]; then
Igor Murashkine5181932017-06-15 16:03:50 -070097 export DESUGAR="$ANDROID_BUILD_TOP/art/tools/desugar.sh"
98fi
99
Igor Murashkin271a0f82017-02-14 21:14:17 +0000100# Zipalign is not on the PATH in some configs, auto-detect it.
101if [ -z "$ZIPALIGN" ]; then
102 if which zipalign >/dev/null; then
103 ZIPALIGN="zipalign";
104 else
105 # TODO: Add a dependency for zipalign in Android.run-test.mk
106 # once it doesn't depend on libandroidfw (b/35246701)
107 case "$OSTYPE" in
108 darwin*) ZIPALIGN="$ANDROID_BUILD_TOP/prebuilts/sdk/tools/darwin/bin/zipalign" ;;
109 linux*) ZIPALIGN="$ANDROID_BUILD_TOP/prebuilts/sdk/tools/linux/bin/zipalign" ;;
110 *) echo "Can't find zipalign: unknown: $OSTYPE" >&2;;
111 esac
112 fi
113fi
114export ZIPALIGN
115
David Brazdil122c6632018-01-24 17:32:49 +0000116# If hiddenapi was not set by the environment variable, assume it is in
117# ANDROID_HOST_OUT.
David Brazdil11b67b22018-01-18 16:41:40 +0000118if [ -z "$HIDDENAPI" ]; then
David Brazdil122c6632018-01-24 17:32:49 +0000119 export HIDDENAPI="${ANDROID_HOST_OUT}/bin/hiddenapi"
David Brazdil11b67b22018-01-18 16:41:40 +0000120fi
121
jeffhao5d1ac922011-09-29 17:41:15 -0700122info="info.txt"
123build="build"
124run="run"
125expected="expected.txt"
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700126check_cmd="check"
jeffhao5d1ac922011-09-29 17:41:15 -0700127output="output.txt"
128build_output="build-output.txt"
David Brazdil24128c62015-05-21 12:06:13 +0100129cfg_output="graph.cfg"
Hiroshi Yamauchi1d4184d2015-07-13 17:11:22 -0700130strace_output="strace-output.txt"
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700131lib="libartd.so"
Mathieu Chartier031768a2015-08-27 10:25:02 -0700132testlib="arttestd"
jeffhao5d1ac922011-09-29 17:41:15 -0700133run_args="--quiet"
David Brazdil4846d132015-01-15 19:07:08 +0000134build_args=""
jeffhao5d1ac922011-09-29 17:41:15 -0700135
Alex Light91de25f2015-10-28 17:00:06 -0700136quiet="no"
Nicolas Geoffraya3d90fb2015-03-16 13:55:40 +0000137debuggable="no"
Alex Light9d722532014-07-22 18:07:12 -0700138prebuild_mode="yes"
Brian Carlstrom2613de42012-06-15 17:37:16 -0700139target_mode="yes"
jeffhao5d1ac922011-09-29 17:41:15 -0700140dev_mode="no"
141update_mode="no"
Alex Lighta59dd802014-07-02 16:28:08 -0700142debug_mode="no"
Nicolas Geoffray94e25db2017-01-27 14:54:28 +0000143relocate="no"
Jeff Hao201803f2013-11-20 18:11:39 -0800144runtime="art"
jeffhao5d1ac922011-09-29 17:41:15 -0700145usage="no"
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700146build_only="no"
Andreas Gampe2fe07922014-04-21 07:50:39 -0700147suffix64=""
Jeff Hao85139a32014-07-23 11:52:52 -0700148trace="false"
Andreas Gampe7526d782015-06-22 22:53:45 -0700149trace_stream="false"
Alex Lighte7873ec2014-08-12 09:53:50 -0700150basic_verify="false"
151gc_verify="false"
152gc_stress="false"
Alex Lightb7edcda2017-04-27 13:20:31 -0700153jvmti_trace_stress="false"
Alex Light43e935d2017-06-19 15:40:40 -0700154jvmti_field_stress="false"
Alex Lightc38c3692017-06-27 15:45:14 -0700155jvmti_step_stress="false"
Alex Lightb7edcda2017-04-27 13:20:31 -0700156jvmti_redefine_stress="false"
Hiroshi Yamauchi1d4184d2015-07-13 17:11:22 -0700157strace="false"
Alex Lightbfac14a2014-07-30 09:41:21 -0700158always_clean="no"
Igor Murashkin05f30e12015-06-10 15:57:17 -0700159never_clean="no"
Alex Light03a112d2014-08-25 13:25:56 -0700160have_dex2oat="yes"
161have_patchoat="yes"
162have_image="yes"
Jeff Haodcdc85b2015-12-04 14:06:18 -0800163multi_image_suffix=""
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000164android_root="/system"
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -0700165bisection_search="no"
Mathieu Chartier3fceaf52017-01-22 13:33:40 -0800166suspend_timeout="500000"
Alex Light10bc5a42016-05-10 10:01:22 -0700167# By default we will use optimizing.
168image_args=""
Nicolas Geoffrayb76bc782016-09-14 12:33:34 +0000169image_suffix=""
jeffhao5d1ac922011-09-29 17:41:15 -0700170
171while true; do
172 if [ "x$1" = "x--host" ]; then
Brian Carlstrom2613de42012-06-15 17:37:16 -0700173 target_mode="no"
TDYa127b92bcab2012-04-08 00:09:51 -0700174 DEX_LOCATION=$tmp_dir
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100175 run_args="${run_args} --host"
jeffhao5d1ac922011-09-29 17:41:15 -0700176 shift
Alex Light91de25f2015-10-28 17:00:06 -0700177 elif [ "x$1" = "x--quiet" ]; then
178 quiet="yes"
179 shift
Alex Lighteb7c1442015-08-31 13:17:42 -0700180 elif [ "x$1" = "x--use-java-home" ]; then
181 if [ -n "${JAVA_HOME}" ]; then
182 export JAVA="${JAVA_HOME}/bin/java"
183 export JAVAC="${JAVA_HOME}/bin/javac -g"
184 else
185 echo "Passed --use-java-home without JAVA_HOME variable set!"
186 usage="yes"
187 fi
188 shift
Elliott Hughes58bcc402012-02-14 14:10:10 -0800189 elif [ "x$1" = "x--jvm" ]; then
Brian Carlstrom2613de42012-06-15 17:37:16 -0700190 target_mode="no"
Alex Light2c7aaeb2017-01-27 14:08:17 -0800191 DEX_LOCATION="$tmp_dir"
Jeff Hao201803f2013-11-20 18:11:39 -0800192 runtime="jvm"
Alex Lightbc90d0f2016-05-09 16:21:09 -0700193 image_args=""
Brian Carlstrom01afdba2014-10-03 10:28:47 -0700194 prebuild_mode="no"
Elliott Hughesc717eef2012-06-15 16:01:26 -0700195 NEED_DEX="false"
Sebastien Hertz19ac0272015-02-24 17:39:50 +0100196 USE_JACK="false"
Nicolas Geoffray288a4a22014-10-07 11:02:40 +0100197 run_args="${run_args} --jvm"
jeffhao5d1ac922011-09-29 17:41:15 -0700198 shift
Elliott Hughes58bcc402012-02-14 14:10:10 -0800199 elif [ "x$1" = "x-O" ]; then
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700200 lib="libart.so"
Mathieu Chartier031768a2015-08-27 10:25:02 -0700201 testlib="arttest"
Alex Lightfaf90b62016-08-12 14:43:48 -0700202 run_args="${run_args} -O"
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700203 shift
204 elif [ "x$1" = "x--dalvik" ]; then
205 lib="libdvm.so"
Jeff Hao201803f2013-11-20 18:11:39 -0800206 runtime="dalvik"
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700207 shift
Alex Light03a112d2014-08-25 13:25:56 -0700208 elif [ "x$1" = "x--no-dex2oat" ]; then
209 have_dex2oat="no"
210 shift
211 elif [ "x$1" = "x--no-patchoat" ]; then
212 have_patchoat="no"
213 shift
214 elif [ "x$1" = "x--no-image" ]; then
215 have_image="no"
216 shift
Jeff Haodcdc85b2015-12-04 14:06:18 -0800217 elif [ "x$1" = "x--multi-image" ]; then
218 multi_image_suffix="-multi"
219 shift
Andreas Gampec23c9c92014-10-28 14:47:25 -0700220 elif [ "x$1" = "x--pic-test" ]; then
221 run_args="${run_args} --pic-test"
222 shift
Alex Lighta59dd802014-07-02 16:28:08 -0700223 elif [ "x$1" = "x--relocate" ]; then
224 relocate="yes"
225 shift
226 elif [ "x$1" = "x--no-relocate" ]; then
227 relocate="no"
228 shift
229 elif [ "x$1" = "x--prebuild" ]; then
Nicolas Geoffray5fd18ba2014-10-03 12:08:38 +0100230 run_args="${run_args} --prebuild"
Alex Lighta59dd802014-07-02 16:28:08 -0700231 prebuild_mode="yes"
232 shift;
Mathieu Chartierdcd56c92017-11-20 20:30:24 -0800233 elif [ "x$1" = "x--compact-dex-level" ]; then
234 option="$1"
235 shift
236 run_args="${run_args} $option $1"
237 shift;
Richard Uhler76f5cb62016-04-04 13:30:16 -0700238 elif [ "x$1" = "x--strip-dex" ]; then
239 run_args="${run_args} --strip-dex"
240 shift;
Nicolas Geoffray43c162f2015-03-09 12:21:26 +0000241 elif [ "x$1" = "x--debuggable" ]; then
242 run_args="${run_args} -Xcompiler-option --debuggable"
Nicolas Geoffraya3d90fb2015-03-16 13:55:40 +0000243 debuggable="yes"
Nicolas Geoffray43c162f2015-03-09 12:21:26 +0000244 shift;
Alex Lighta59dd802014-07-02 16:28:08 -0700245 elif [ "x$1" = "x--no-prebuild" ]; then
Nicolas Geoffray5fd18ba2014-10-03 12:08:38 +0100246 run_args="${run_args} --no-prebuild"
Alex Lighta59dd802014-07-02 16:28:08 -0700247 prebuild_mode="no"
248 shift;
Alex Lighte7873ec2014-08-12 09:53:50 -0700249 elif [ "x$1" = "x--gcverify" ]; then
250 basic_verify="true"
251 gc_verify="true"
252 shift
253 elif [ "x$1" = "x--gcstress" ]; then
254 basic_verify="true"
255 gc_stress="true"
256 shift
Alex Lightc38c3692017-06-27 15:45:14 -0700257 elif [ "x$1" = "x--jvmti-step-stress" ]; then
258 jvmti_step_stress="true"
259 shift
Alex Lightb7edcda2017-04-27 13:20:31 -0700260 elif [ "x$1" = "x--jvmti-redefine-stress" ]; then
261 jvmti_redefine_stress="true"
262 shift
Alex Light43e935d2017-06-19 15:40:40 -0700263 elif [ "x$1" = "x--jvmti-field-stress" ]; then
264 jvmti_field_stress="true"
265 shift
Alex Lightb7edcda2017-04-27 13:20:31 -0700266 elif [ "x$1" = "x--jvmti-trace-stress" ]; then
267 jvmti_trace_stress="true"
Alex Light8f2c6d42017-04-10 16:27:35 -0700268 shift
Mathieu Chartier3fceaf52017-01-22 13:33:40 -0800269 elif [ "x$1" = "x--suspend-timeout" ]; then
270 shift
271 suspend_timeout="$1"
272 shift
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700273 elif [ "x$1" = "x--image" ]; then
274 shift
275 image="$1"
276 run_args="${run_args} --image $image"
Elliott Hughes7c046102011-10-19 18:16:03 -0700277 shift
Nicolas Geoffray92cf83e2014-03-18 17:59:20 +0000278 elif [ "x$1" = "x-Xcompiler-option" ]; then
279 shift
280 option="$1"
281 run_args="${run_args} -Xcompiler-option $option"
282 shift
Orion Hodsone1fb77f2017-02-27 13:57:18 +0000283 elif [ "x$1" = "x--build-option" ]; then
284 shift
285 option="$1"
286 build_args="${build_args} $option"
287 shift
Mathieu Chartier769a5ad2014-05-18 15:30:10 -0700288 elif [ "x$1" = "x--runtime-option" ]; then
289 shift
290 option="$1"
291 run_args="${run_args} --runtime-option $option"
292 shift
Mathieu Chartierc0a8a802014-10-17 15:58:01 -0700293 elif [ "x$1" = "x--gdb-arg" ]; then
294 shift
295 gdb_arg="$1"
296 run_args="${run_args} --gdb-arg $gdb_arg"
297 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700298 elif [ "x$1" = "x--debug" ]; then
299 run_args="${run_args} --debug"
300 shift
Alex Lightc281ba52017-10-11 11:35:55 -0700301 elif [ "x$1" = "x--debug-wrap-agent" ]; then
302 run_args="${run_args} --debug-wrap-agent"
303 shift
Alex Light0e151e72017-10-25 10:50:35 -0700304 elif [ "x$1" = "x--with-agent" ]; then
305 shift
306 option="$1"
307 run_args="${run_args} --with-agent $1"
308 shift
Alex Lightc281ba52017-10-11 11:35:55 -0700309 elif [ "x$1" = "x--debug-agent" ]; then
310 shift
311 option="$1"
312 run_args="${run_args} --debug-agent $1"
313 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700314 elif [ "x$1" = "x--gdb" ]; then
315 run_args="${run_args} --gdb"
316 dev_mode="yes"
317 shift
Hiroshi Yamauchi1d4184d2015-07-13 17:11:22 -0700318 elif [ "x$1" = "x--strace" ]; then
319 strace="yes"
Mathieu Chartier2576be22016-05-24 10:24:53 -0700320 run_args="${run_args} --timeout 1800 --invoke-with strace --invoke-with -o --invoke-with $tmp_dir/$strace_output"
Hiroshi Yamauchi1d4184d2015-07-13 17:11:22 -0700321 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700322 elif [ "x$1" = "x--zygote" ]; then
323 run_args="${run_args} --zygote"
324 shift
jeffhao0dff3f42012-11-20 15:13:43 -0800325 elif [ "x$1" = "x--interpreter" ]; then
Nicolas Geoffray4650c932016-05-10 09:13:13 +0000326 run_args="${run_args} --interpreter"
Andreas Gampe63fc30e2014-10-24 21:58:16 -0700327 image_suffix="-interpreter"
328 shift
Mathieu Chartiere5f13e52015-02-24 09:37:21 -0800329 elif [ "x$1" = "x--jit" ]; then
Alex Light10bc5a42016-05-10 10:01:22 -0700330 image_args="--jit"
Nicolas Geoffrayb76bc782016-09-14 12:33:34 +0000331 image_suffix="-interpreter"
Mathieu Chartiere5f13e52015-02-24 09:37:21 -0800332 shift
Andreas Gampe63fc30e2014-10-24 21:58:16 -0700333 elif [ "x$1" = "x--optimizing" ]; then
Alex Light10bc5a42016-05-10 10:01:22 -0700334 image_args="-Xcompiler-option --compiler-backend=Optimizing"
jeffhao0dff3f42012-11-20 15:13:43 -0800335 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700336 elif [ "x$1" = "x--no-verify" ]; then
Richard Uhlerf4b34872016-04-13 11:03:46 -0700337 run_args="${run_args} --no-verify"
jeffhao5d1ac922011-09-29 17:41:15 -0700338 shift
Igor Murashkin7617abd2015-07-10 18:27:47 -0700339 elif [ "x$1" = "x--verify-soft-fail" ]; then
Alex Light10bc5a42016-05-10 10:01:22 -0700340 image_args="--verify-soft-fail"
Andreas Gampe825570c2015-07-26 10:26:03 -0700341 image_suffix="-interp-ac"
Igor Murashkin7617abd2015-07-10 18:27:47 -0700342 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700343 elif [ "x$1" = "x--no-optimize" ]; then
344 run_args="${run_args} --no-optimize"
345 shift
346 elif [ "x$1" = "x--no-precise" ]; then
347 run_args="${run_args} --no-precise"
348 shift
Elliott Hughes7c046102011-10-19 18:16:03 -0700349 elif [ "x$1" = "x--invoke-with" ]; then
350 shift
351 what="$1"
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700352 if [ "x$what" = "x" ]; then
353 echo "$0 missing argument to --invoke-with" 1>&2
354 usage="yes"
355 break
356 fi
Ian Rogers0e033672013-04-19 10:22:46 -0700357 run_args="${run_args} --invoke-with ${what}"
jeffhao5d1ac922011-09-29 17:41:15 -0700358 shift
359 elif [ "x$1" = "x--dev" ]; then
360 run_args="${run_args} --dev"
361 dev_mode="yes"
362 shift
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700363 elif [ "x$1" = "x--build-only" ]; then
364 build_only="yes"
365 shift
Alan Leung0afa07a2017-10-03 16:56:30 -0700366 elif [ "x$1" = "x--build-with-d8" ]; then
367 USE_D8="true"
368 shift
Sebastien Hertz19ac0272015-02-24 17:39:50 +0100369 elif [ "x$1" = "x--build-with-javac-dx" ]; then
370 USE_JACK="false"
371 shift
372 elif [ "x$1" = "x--build-with-jack" ]; then
373 USE_JACK="true"
374 shift
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700375 elif [ "x$1" = "x--output-path" ]; then
376 shift
377 tmp_dir=$1
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700378 if [ "x$tmp_dir" = "x" ]; then
379 echo "$0 missing argument to --output-path" 1>&2
380 usage="yes"
381 break
382 fi
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700383 shift
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000384 elif [ "x$1" = "x--android-root" ]; then
385 shift
386 if [ "x$1" = "x" ]; then
387 echo "$0 missing argument to --android-root" 1>&2
388 usage="yes"
389 break
390 fi
391 android_root="$1"
392 run_args="${run_args} --android-root $1"
393 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700394 elif [ "x$1" = "x--update" ]; then
395 update_mode="yes"
396 shift
397 elif [ "x$1" = "x--help" ]; then
398 usage="yes"
399 shift
Andreas Gampeafbaa1a2014-03-25 18:09:32 -0700400 elif [ "x$1" = "x--64" ]; then
401 run_args="${run_args} --64"
Andreas Gampe2fe07922014-04-21 07:50:39 -0700402 suffix64="64"
Andreas Gampeafbaa1a2014-03-25 18:09:32 -0700403 shift
Sebastien Hertz07aaac82014-07-09 15:59:05 +0200404 elif [ "x$1" = "x--trace" ]; then
Jeff Hao85139a32014-07-23 11:52:52 -0700405 trace="true"
Sebastien Hertz07aaac82014-07-09 15:59:05 +0200406 shift
Andreas Gampe7526d782015-06-22 22:53:45 -0700407 elif [ "x$1" = "x--stream" ]; then
408 trace_stream="true"
409 shift
Alex Lightbfac14a2014-07-30 09:41:21 -0700410 elif [ "x$1" = "x--always-clean" ]; then
411 always_clean="yes"
412 shift
Igor Murashkin05f30e12015-06-10 15:57:17 -0700413 elif [ "x$1" = "x--never-clean" ]; then
414 never_clean="yes"
415 shift
Andreas Gampee21dc3d2014-12-08 16:59:43 -0800416 elif [ "x$1" = "x--dex2oat-swap" ]; then
417 run_args="${run_args} --dex2oat-swap"
418 shift
Andreas Gampe4d2ef332015-08-05 09:24:45 -0700419 elif [ "x$1" = "x--instruction-set-features" ]; then
420 shift
421 run_args="${run_args} --instruction-set-features $1"
422 shift
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -0700423 elif [ "x$1" = "x--bisection-search" ]; then
424 bisection_search="yes"
425 shift
Nicolas Geoffrayb0bbe8e2016-11-19 10:42:37 +0000426 elif [ "x$1" = "x--vdex" ]; then
427 run_args="${run_args} --vdex"
428 shift
Nicolas Geoffraybaeaa9b2018-01-26 14:31:17 +0000429 elif [ "x$1" = "x--dm" ]; then
430 run_args="${run_args} --dm"
431 shift
Nicolas Geoffray74981052017-01-16 17:54:09 +0000432 elif [ "x$1" = "x--vdex-filter" ]; then
433 shift
434 filter=$1
435 run_args="${run_args} --vdex-filter $filter"
436 shift
Jeff Hao002b9312017-03-27 16:23:08 -0700437 elif [ "x$1" = "x--random-profile" ]; then
438 run_args="${run_args} --random-profile"
439 shift
Shubham Ajmera981d99c2017-08-17 14:11:08 -0700440 elif [ "x$1" = "x--dex2oat-jobs" ]; then
441 shift
442 run_args="${run_args} -Xcompiler-option -j$1"
443 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700444 elif expr "x$1" : "x--" >/dev/null 2>&1; then
Elliott Hughes7c046102011-10-19 18:16:03 -0700445 echo "unknown $0 option: $1" 1>&2
jeffhao5d1ac922011-09-29 17:41:15 -0700446 usage="yes"
447 break
448 else
449 break
450 fi
451done
Andreas Gampe3a12cfe2014-08-13 15:40:22 -0700452
Alex Light10bc5a42016-05-10 10:01:22 -0700453run_args="${run_args} ${image_args}"
Alex Light91de25f2015-10-28 17:00:06 -0700454# Allocate file descriptor real_stderr and redirect it to the shell's error
455# output (fd 2).
456if [ ${BASH_VERSINFO[1]} -ge 4 ] && [ ${BASH_VERSINFO[2]} -ge 1 ]; then
457 exec {real_stderr}>&2
458else
459 # In bash before version 4.1 we need to do a manual search for free file
460 # descriptors.
461 FD=3
462 while [ -e /dev/fd/$FD ]; do FD=$((FD + 1)); done
463 real_stderr=$FD
464 eval "exec ${real_stderr}>&2"
465fi
466if [ "$quiet" = "yes" ]; then
467 # Force the default standard output and error to go to /dev/null so we will
468 # not print them.
469 exec 1>/dev/null
470 exec 2>/dev/null
471fi
472
473function err_echo() {
474 echo "$@" 1>&${real_stderr}
475}
476
Andreas Gampe3a12cfe2014-08-13 15:40:22 -0700477# tmp_dir may be relative, resolve.
478#
479# Cannot use realpath, as it does not exist on Mac.
480# Cannot us a simple "cd", as the path might not be created yet.
Brian Carlstromc580e042014-09-08 21:37:39 -0700481# Cannot use readlink -m, as it does not exist on Mac.
482# Fallback to nuclear option:
Andreas Gampe907b6992014-08-18 22:26:49 -0700483noncanonical_tmp_dir=$tmp_dir
Brian Carlstromc580e042014-09-08 21:37:39 -0700484tmp_dir="`cd $oldwd ; python -c "import os; print os.path.realpath('$tmp_dir')"`"
Dmitry Petrochenko81c56e72014-03-05 15:05:46 +0700485mkdir -p $tmp_dir
jeffhao5d1ac922011-09-29 17:41:15 -0700486
Mathieu Chartier3fceaf52017-01-22 13:33:40 -0800487# Add thread suspend timeout flag
Narayan Kamathf86c3932017-01-24 17:40:47 +0000488if [ ! "$runtime" = "jvm" ]; then
489 run_args="${run_args} --runtime-option -XX:ThreadSuspendTimeout=$suspend_timeout"
490fi
Mathieu Chartier3fceaf52017-01-22 13:33:40 -0800491
Alex Lighte7873ec2014-08-12 09:53:50 -0700492if [ "$basic_verify" = "true" ]; then
Hiroshi Yamauchi312baf12015-01-12 12:11:05 -0800493 # Set HspaceCompactForOOMMinIntervalMs to zero to run hspace compaction for OOM more frequently in tests.
494 run_args="${run_args} --runtime-option -Xgc:preverify --runtime-option -Xgc:postverify --runtime-option -XX:HspaceCompactForOOMMinIntervalMs=0"
Alex Lighte7873ec2014-08-12 09:53:50 -0700495fi
496if [ "$gc_verify" = "true" ]; then
497 run_args="${run_args} --runtime-option -Xgc:preverify_rosalloc --runtime-option -Xgc:postverify_rosalloc"
498fi
499if [ "$gc_stress" = "true" ]; then
Mathieu Chartierd9eb2842016-08-12 16:11:24 -0700500 run_args="${run_args} --gc-stress --runtime-option -Xgc:gcstress --runtime-option -Xms2m --runtime-option -Xmx16m"
Alex Lighte7873ec2014-08-12 09:53:50 -0700501fi
Alex Lightb7edcda2017-04-27 13:20:31 -0700502if [ "$jvmti_redefine_stress" = "true" ]; then
503 run_args="${run_args} --no-app-image --jvmti-redefine-stress"
504fi
Alex Lightc38c3692017-06-27 15:45:14 -0700505if [ "$jvmti_step_stress" = "true" ]; then
506 run_args="${run_args} --no-app-image --jvmti-step-stress"
507fi
Alex Light43e935d2017-06-19 15:40:40 -0700508if [ "$jvmti_field_stress" = "true" ]; then
509 run_args="${run_args} --no-app-image --jvmti-field-stress"
510fi
Alex Lightb7edcda2017-04-27 13:20:31 -0700511if [ "$jvmti_trace_stress" = "true" ]; then
512 run_args="${run_args} --no-app-image --jvmti-trace-stress"
Alex Light8f2c6d42017-04-10 16:27:35 -0700513fi
Jeff Hao85139a32014-07-23 11:52:52 -0700514if [ "$trace" = "true" ]; then
Andreas Gampe7526d782015-06-22 22:53:45 -0700515 run_args="${run_args} --runtime-option -Xmethod-trace --runtime-option -Xmethod-trace-file-size:2000000"
516 if [ "$trace_stream" = "true" ]; then
517 # Streaming mode uses the file size as the buffer size. So output gets really large. Drop
518 # the ability to analyze the file and just write to /dev/null.
519 run_args="${run_args} --runtime-option -Xmethod-trace-file:/dev/null"
520 # Enable streaming mode.
521 run_args="${run_args} --runtime-option -Xmethod-trace-stream"
522 else
523 run_args="${run_args} --runtime-option -Xmethod-trace-file:${DEX_LOCATION}/trace.bin"
524 fi
525elif [ "$trace_stream" = "true" ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700526 err_echo "Cannot use --stream without --trace."
Andreas Gampe7526d782015-06-22 22:53:45 -0700527 exit 1
Jeff Hao85139a32014-07-23 11:52:52 -0700528fi
529
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700530# Most interesting target architecture variables are Makefile variables, not environment variables.
Nicolas Geoffray93d68462018-01-02 11:59:45 +0000531# Try to map the suffix64 flag and what we find in ${ANDROID_PRODUCT_OUT}/data/art-test to an architecture name.
David Brazdil853a4c32015-09-28 16:15:50 +0100532function guess_target_arch_name() {
Nicolas Geoffray93d68462018-01-02 11:59:45 +0000533 grep32bit=`ls ${ANDROID_PRODUCT_OUT}/data/art-test | grep -E '^(arm|x86|mips)$'`
534 grep64bit=`ls ${ANDROID_PRODUCT_OUT}/data/art-test | grep -E '^(arm64|x86_64|mips64)$'`
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700535 if [ "x${suffix64}" = "x64" ]; then
536 target_arch_name=${grep64bit}
537 else
538 target_arch_name=${grep32bit}
539 fi
540}
541
David Brazdil853a4c32015-09-28 16:15:50 +0100542function guess_host_arch_name() {
543 if [ "x${suffix64}" = "x64" ]; then
544 host_arch_name="x86_64"
545 else
546 host_arch_name="x86"
547 fi
548}
549
Alex Lighta59dd802014-07-02 16:28:08 -0700550if [ "$target_mode" = "no" ]; then
551 if [ "$runtime" = "jvm" ]; then
Alex Lighta59dd802014-07-02 16:28:08 -0700552 if [ "$prebuild_mode" = "yes" ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700553 err_echo "--prebuild with --jvm is unsupported"
Alex Lighta59dd802014-07-02 16:28:08 -0700554 exit 1;
555 fi
Alex Lighta59dd802014-07-02 16:28:08 -0700556 fi
557fi
558
Alex Light03a112d2014-08-25 13:25:56 -0700559if [ "$have_patchoat" = "no" ]; then
560 run_args="${run_args} --no-patchoat"
561fi
562
563if [ "$have_dex2oat" = "no" ]; then
564 run_args="${run_args} --no-dex2oat"
565fi
566
Jeff Hao201803f2013-11-20 18:11:39 -0800567if [ ! "$runtime" = "jvm" ]; then
568 run_args="${run_args} --lib $lib"
569fi
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700570
Jeff Hao201803f2013-11-20 18:11:39 -0800571if [ "$runtime" = "dalvik" ]; then
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700572 if [ "$target_mode" = "no" ]; then
Nicolas Geoffray93d68462018-01-02 11:59:45 +0000573 framework="${ANDROID_PRODUCT_OUT}/system/framework"
Andreas Gampe50be66f2015-12-28 14:31:06 -0800574 bpath="${framework}/core-libart.jar:${framework}/core-oj.jar:${framework}/conscrypt.jar:${framework}/okhttp.jar:${framework}/bouncycastle.jar:${framework}/ext.jar"
Richard Uhler76f5cb62016-04-04 13:30:16 -0700575 run_args="${run_args} --boot --runtime-option -Xbootclasspath:${bpath}"
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700576 else
577 true # defaults to using target BOOTCLASSPATH
578 fi
Jeff Hao201803f2013-11-20 18:11:39 -0800579elif [ "$runtime" = "art" ]; then
580 if [ "$target_mode" = "no" ]; then
David Brazdil853a4c32015-09-28 16:15:50 +0100581 guess_host_arch_name
Richard Uhlerbb00f812017-02-16 14:21:10 +0000582 run_args="${run_args} --boot ${ANDROID_HOST_OUT}/framework/core${image_suffix}${multi_image_suffix}.art"
Colin Crossafd3c9e2016-09-16 13:47:21 -0700583 run_args="${run_args} --runtime-option -Djava.library.path=${ANDROID_HOST_OUT}/lib${suffix64}:${ANDROID_HOST_OUT}/nativetest${suffix64}"
Jeff Hao201803f2013-11-20 18:11:39 -0800584 else
David Brazdil853a4c32015-09-28 16:15:50 +0100585 guess_target_arch_name
Dimitry Ivanov49c2c922017-02-14 11:06:14 -0800586 run_args="${run_args} --runtime-option -Djava.library.path=/data/nativetest${suffix64}/art/${target_arch_name}"
Richard Uhlerbb00f812017-02-16 14:21:10 +0000587 run_args="${run_args} --boot /data/art-test/core${image_suffix}${multi_image_suffix}.art"
Jeff Hao201803f2013-11-20 18:11:39 -0800588 fi
Alex Lighta59dd802014-07-02 16:28:08 -0700589 if [ "$relocate" = "yes" ]; then
590 run_args="${run_args} --relocate"
591 else
592 run_args="${run_args} --no-relocate"
593 fi
Andreas Gampe3f1dc562015-05-18 15:52:22 -0700594elif [ "$runtime" = "jvm" ]; then
595 # TODO: Detect whether the host is 32-bit or 64-bit.
Alex Lightfba89fe2017-01-12 16:11:02 -0800596 run_args="${run_args} --runtime-option -Djava.library.path=${ANDROID_HOST_OUT}/lib64:${ANDROID_HOST_OUT}/nativetest64"
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700597fi
598
Alex Light03a112d2014-08-25 13:25:56 -0700599if [ "$have_image" = "no" ]; then
Alex Light1ef4ce82014-08-27 11:13:47 -0700600 if [ "$runtime" != "art" ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700601 err_echo "--no-image is only supported on the art runtime"
Alex Light1ef4ce82014-08-27 11:13:47 -0700602 exit 1
603 fi
Alex Light03a112d2014-08-25 13:25:56 -0700604 run_args="${run_args} --no-image"
605fi
606
jeffhao5d1ac922011-09-29 17:41:15 -0700607if [ "$dev_mode" = "yes" -a "$update_mode" = "yes" ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700608 err_echo "--dev and --update are mutually exclusive"
609 usage="yes"
610fi
611
612if [ "$dev_mode" = "yes" -a "$quiet" = "yes" ]; then
613 err_echo "--dev and --quiet are mutually exclusive"
jeffhao5d1ac922011-09-29 17:41:15 -0700614 usage="yes"
615fi
616
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -0700617if [ "$bisection_search" = "yes" -a "$prebuild_mode" = "yes" ]; then
618 err_echo "--bisection-search and --prebuild are mutually exclusive"
619 usage="yes"
620fi
621
622if [ "$bisection_search" = "yes" -a "$have_dex2oat" = "no" ]; then
623 err_echo "--bisection-search and --no-dex2oat are mutually exclusive"
624 usage="yes"
625fi
626
627if [ "$bisection_search" = "yes" -a "$have_patchoat" = "no" ]; then
628 err_echo "--bisection-search and --no-patchoat are mutually exclusive"
629 usage="yes"
630fi
631
jeffhao5d1ac922011-09-29 17:41:15 -0700632if [ "$usage" = "no" ]; then
633 if [ "x$1" = "x" -o "x$1" = "x-" ]; then
634 test_dir=`basename "$oldwd"`
635 else
636 test_dir="$1"
637 fi
638
639 if [ '!' -d "$test_dir" ]; then
640 td2=`echo ${test_dir}-*`
641 if [ '!' -d "$td2" ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700642 err_echo "${test_dir}: no such test directory"
jeffhao5d1ac922011-09-29 17:41:15 -0700643 usage="yes"
644 fi
645 test_dir="$td2"
646 fi
jeffhao5d1ac922011-09-29 17:41:15 -0700647 # Shift to get rid of the test name argument. The rest of the arguments
648 # will get passed to the test run.
649 shift
650fi
651
Søren Gjesse620d0a52016-09-19 11:12:51 +0200652# For building with javac and dx always use Java 7. The dx compiler
653# only support byte codes from Java 7 or earlier (class file major
654# version 51 or lower).
655if [ "$USE_JACK" != "true" ] && [ "$NEED_DEX" = "true" ]; then
656 export JAVAC="${JAVAC} -source 1.7 -target 1.7"
657fi
658
jeffhao5d1ac922011-09-29 17:41:15 -0700659if [ "$usage" = "yes" ]; then
660 prog=`basename $prog`
661 (
662 echo "usage:"
663 echo " $prog --help Print this message."
664 echo " $prog [options] [test-name] Run test normally."
665 echo " $prog --dev [options] [test-name] Development mode" \
666 "(dumps to stdout)."
667 echo " $prog --update [options] [test-name] Update mode" \
668 "(replaces expected.txt)."
669 echo ' Omitting the test name or specifying "-" will use the' \
670 "current directory."
671 echo " Runtime Options:"
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000672 echo " -O Run non-debug rather than debug build (off by default)."
673 echo " -Xcompiler-option Pass an option to the compiler."
Orion Hodsone1fb77f2017-02-27 13:57:18 +0000674 echo " --build-option Pass an option to the build script."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000675 echo " --runtime-option Pass an option to the runtime."
Mathieu Chartierdcd56c92017-11-20 20:30:24 -0800676 echo " --compact-dex-level Specify a compact dex level to the compiler."
Alex Lightc281ba52017-10-11 11:35:55 -0700677 echo " --debug Wait for the default debugger to attach."
678 echo " --debug-agent <agent-path>"
679 echo " Wait for the given debugger agent to attach. Currently"
680 echo " only supported on host."
681 echo " --debug-wrap-agent use libwrapagentproperties and tools/libjdwp-compat.props"
682 echo " to load the debugger agent specified by --debug-agent."
Alex Light0e151e72017-10-25 10:50:35 -0700683 echo " --with-agent <agent> Run the test with the given agent loaded with -agentpath:"
Nicolas Geoffray43c162f2015-03-09 12:21:26 +0000684 echo " --debuggable Whether to compile Java code for a debugger."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000685 echo " --gdb Run under gdb; incompatible with some tests."
Alex Lightfadfee92015-10-28 09:40:10 -0700686 echo " --gdb-arg Pass an option to gdb."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000687 echo " --build-only Build test files only (off by default)."
Alan Leung0afa07a2017-10-03 16:56:30 -0700688 echo " --build-with-d8 Build test files with javac and d8 (off by default)."
Søren Gjesse620d0a52016-09-19 11:12:51 +0200689 echo " --build-with-javac-dx Build test files with javac and dx (off by default)."
690 echo " --build-with-jack Build test files with jack and jill (on by default)."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000691 echo " --interpreter Enable interpreter only mode (off by default)."
Mathieu Chartiere5f13e52015-02-24 09:37:21 -0800692 echo " --jit Enable jit (off by default)."
Nicolas Geoffray0e071252015-03-21 13:43:15 +0000693 echo " --optimizing Enable optimizing compiler (default)."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000694 echo " --no-verify Turn off verification (on by default)."
Igor Murashkin7617abd2015-07-10 18:27:47 -0700695 echo " --verify-soft-fail Force soft fail verification (off by default)."
696 echo " Verification is enabled if neither --no-verify"
697 echo " nor --verify-soft-fail is specified."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000698 echo " --no-optimize Turn off optimization (on by default)."
699 echo " --no-precise Turn off precise GC (on by default)."
700 echo " --zygote Spawn the process from the Zygote." \
jeffhao5d1ac922011-09-29 17:41:15 -0700701 "If used, then the"
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000702 echo " other runtime options are ignored."
703 echo " --no-dex2oat Run as though dex2oat was failing."
704 echo " --no-patchoat Run as though patchoat was failing."
705 echo " --prebuild Run dex2oat on the files before starting test. (default)"
706 echo " --no-prebuild Do not run dex2oat on the files before starting"
707 echo " the test."
Richard Uhler76f5cb62016-04-04 13:30:16 -0700708 echo " --strip-dex Strip the dex files before starting test."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000709 echo " --relocate Force the use of relocating in the test, making"
710 echo " the image and oat files be relocated to a random"
Nicolas Geoffray94e25db2017-01-27 14:54:28 +0000711 echo " address before running."
712 echo " --no-relocate Force the use of no relocating in the test. (default)"
Alex Lightfadfee92015-10-28 09:40:10 -0700713 echo " --image Run the test using a precompiled boot image. (default)"
714 echo " --no-image Run the test without a precompiled boot image."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000715 echo " --host Use the host-mode virtual machine."
716 echo " --invoke-with Pass --invoke-with option to runtime."
717 echo " --dalvik Use Dalvik (off by default)."
718 echo " --jvm Use a host-local RI virtual machine."
Alex Lighteb7c1442015-08-31 13:17:42 -0700719 echo " --use-java-home Use the JAVA_HOME environment variable"
720 echo " to find the java compiler and runtime"
721 echo " (if applicable) to run the test with."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000722 echo " --output-path [path] Location where to store the build" \
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700723 "files."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000724 echo " --64 Run the test in 64-bit mode"
725 echo " --trace Run with method tracing"
Alex Lightfadfee92015-10-28 09:40:10 -0700726 echo " --strace Run with syscall tracing from strace."
Andreas Gampe7526d782015-06-22 22:53:45 -0700727 echo " --stream Run method tracing in streaming mode (requires --trace)"
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000728 echo " --gcstress Run with gc stress testing"
729 echo " --gcverify Run with gc verification"
Alex Lightb7edcda2017-04-27 13:20:31 -0700730 echo " --jvmti-trace-stress Run with jvmti method tracing stress testing"
Alex Lightc38c3692017-06-27 15:45:14 -0700731 echo " --jvmti-step-stress Run with jvmti single step stress testing"
Alex Lightb7edcda2017-04-27 13:20:31 -0700732 echo " --jvmti-redefine-stress"
733 echo " Run with jvmti method redefinition stress testing"
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000734 echo " --always-clean Delete the test files even if the test fails."
Igor Murashkin05f30e12015-06-10 15:57:17 -0700735 echo " --never-clean Keep the test files even if the test succeeds."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000736 echo " --android-root [path] The path on target for the android root. (/system by default)."
Nicolas Geoffray43c162f2015-03-09 12:21:26 +0000737 echo " --dex2oat-swap Use a dex2oat swap file."
Andreas Gampe4d2ef332015-08-05 09:24:45 -0700738 echo " --instruction-set-features [string]"
739 echo " Set instruction-set-features for compilation."
Jeff Haodcdc85b2015-12-04 14:06:18 -0800740 echo " --multi-image Use a set of images compiled with dex2oat multi-image for"
741 echo " the boot class path."
Alex Lightfadfee92015-10-28 09:40:10 -0700742 echo " --pic-test Compile the test code position independent."
Alex Light91de25f2015-10-28 17:00:06 -0700743 echo " --quiet Don't print anything except failure messages"
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -0700744 echo " --bisection-search Perform bisection bug search."
Nicolas Geoffrayb0bbe8e2016-11-19 10:42:37 +0000745 echo " --vdex Test using vdex as in input to dex2oat. Only works with --prebuild."
Mathieu Chartier3fceaf52017-01-22 13:33:40 -0800746 echo " --suspend-timeout Change thread suspend timeout ms (default 500000)."
Shubham Ajmera981d99c2017-08-17 14:11:08 -0700747 echo " --dex2oat-jobs Number of dex2oat jobs."
Alex Light91de25f2015-10-28 17:00:06 -0700748 ) 1>&2 # Direct to stderr so usage is not printed if --quiet is set.
jeffhao5d1ac922011-09-29 17:41:15 -0700749 exit 1
750fi
751
752cd "$test_dir"
753test_dir=`pwd`
754
755td_info="${test_dir}/${info}"
756td_expected="${test_dir}/${expected}"
757
Brian Carlstrom22469aa2012-09-07 10:34:57 -0700758if [ ! -r $td_info ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700759 err_echo "${test_dir}: missing file $td_info"
Brian Carlstrom22469aa2012-09-07 10:34:57 -0700760 exit 1
761fi
762
763if [ ! -r $td_expected ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700764 err_echo "${test_dir}: missing file $td_expected"
jeffhao5d1ac922011-09-29 17:41:15 -0700765 exit 1
766fi
767
768# copy the test to a temp dir and run it
769
Elliott Hughes510c8782011-10-06 10:57:34 -0700770echo "${test_dir}: building..." 1>&2
jeffhao5d1ac922011-09-29 17:41:15 -0700771
772rm -rf "$tmp_dir"
773cp -Rp "$test_dir" "$tmp_dir"
774cd "$tmp_dir"
775
776if [ '!' -r "$build" ]; then
777 cp "${progdir}/etc/default-build" build
Zheng Xuc6667102015-05-15 16:08:45 +0800778else
779 cp "${progdir}/etc/default-build" .
jeffhao5d1ac922011-09-29 17:41:15 -0700780fi
781
782if [ '!' -r "$run" ]; then
783 cp "${progdir}/etc/default-run" run
Zheng Xuc6667102015-05-15 16:08:45 +0800784else
785 cp "${progdir}/etc/default-run" .
jeffhao5d1ac922011-09-29 17:41:15 -0700786fi
787
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700788if [ '!' -r "$check_cmd" ]; then
789 cp "${progdir}/etc/default-check" check
Zheng Xuc6667102015-05-15 16:08:45 +0800790else
791 cp "${progdir}/etc/default-check" .
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700792fi
793
jeffhao5d1ac922011-09-29 17:41:15 -0700794chmod 755 "$build"
795chmod 755 "$run"
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700796chmod 755 "$check_cmd"
jeffhao5d1ac922011-09-29 17:41:15 -0700797
Elliott Hughes8cbc8bc2011-10-04 11:19:45 -0700798export TEST_NAME=`basename ${test_dir}`
799
Nicolas Geoffray1949baf2017-10-17 12:14:53 +0000800# Tests named '<number>-checker-*' will also have their CFGs verified with
801# Checker when compiled with Optimizing on host.
802if [[ "$TEST_NAME" =~ ^[0-9]+-checker- ]]; then
803 if [ "$runtime" = "art" -a "$image_suffix" = "" ]; then
804 # In no-prebuild or no-image mode, the compiler only quickens so disable the checker.
805 if [ "$prebuild_mode" = "yes" -a "$have_image" = "yes" ]; then
806 run_checker="yes"
807
808 if [ "$target_mode" = "no" ]; then
809 cfg_output_dir="$tmp_dir"
810 checker_args="--arch=${host_arch_name^^}"
811 else
812 cfg_output_dir="$DEX_LOCATION"
813 checker_args="--arch=${target_arch_name^^}"
814 fi
815
816 if [ "$debuggable" = "yes" ]; then
817 checker_args="$checker_args --debuggable"
818 fi
819
820 run_args="${run_args} -Xcompiler-option --dump-cfg=$cfg_output_dir/$cfg_output \
821 -Xcompiler-option -j1"
822 fi
823 fi
824fi
825
Mathieu Chartier031768a2015-08-27 10:25:02 -0700826 run_args="${run_args} --testlib ${testlib}"
Mathieu Chartier031768a2015-08-27 10:25:02 -0700827
Richard Uhler020c0f32017-03-14 16:23:17 +0000828# To cause tests to fail fast, limit the file sizes created by dx, dex2oat and
829# ART output to approximately 128MB. This should be more than sufficient
830# for any test while still catching cases of runaway output.
831# Set a hard limit to encourage ART developers to increase the ulimit here if
832# needed to support a test case rather than resetting the limit in the run
833# script for the particular test in question.
Orion Hodsonbd328d32017-03-24 11:24:10 +0000834if ! ulimit -f 128000; then
Richard Uhler020c0f32017-03-14 16:23:17 +0000835 err_echo "ulimit file size setting failed"
Ian Rogers997f0f92014-06-21 22:58:05 -0700836fi
837
Igor Murashkin2de6e082018-02-28 15:25:23 -0800838# Tell the build script which mode (target, host, jvm) we are building for
839# to determine the bootclasspath at build time.
Igor Murashkin2a337752017-06-16 14:34:40 +0000840if [[ "$target_mode" == "yes" ]]; then
841 build_args="$build_args --target"
842else
Igor Murashkin2de6e082018-02-28 15:25:23 -0800843 if [[ $runtime == "jvm" ]]; then
844 build_args="$build_args --jvm"
845 else
846 build_args="$build_args --host"
847 fi
Igor Murashkin2a337752017-06-16 14:34:40 +0000848fi
849
850if [[ "$dev_mode" == "yes" ]]; then
851 build_args="$build_args --dev"
852fi
853
jeffhao5d1ac922011-09-29 17:41:15 -0700854good="no"
Nicolas Geoffray1ed097d2014-11-13 15:15:39 +0000855good_build="yes"
856good_run="yes"
Alex Light77fee872017-09-05 14:51:49 -0700857export TEST_RUNTIME="${runtime}"
jeffhao5d1ac922011-09-29 17:41:15 -0700858if [ "$dev_mode" = "yes" ]; then
David Brazdil4846d132015-01-15 19:07:08 +0000859 "./${build}" $build_args 2>&1
Elliott Hughes7ab3a2a2012-06-18 16:34:20 -0700860 build_exit="$?"
861 echo "build exit status: $build_exit" 1>&2
862 if [ "$build_exit" = '0' ]; then
Elliott Hughes2bfc6732012-11-27 20:40:51 -0800863 echo "${test_dir}: running..." 1>&2
864 "./${run}" $run_args "$@" 2>&1
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700865 run_exit="$?"
Calin Juravle3cf48772015-01-26 16:47:33 +0000866
Brian Carlstrom700c8d32012-11-05 10:42:02 -0800867 if [ "$run_exit" = "0" ]; then
Calin Juravle3cf48772015-01-26 16:47:33 +0000868 if [ "$run_checker" = "yes" ]; then
Alexandre Rames5e2c8d32015-08-06 14:49:28 +0100869 if [ "$target_mode" = "yes" ]; then
870 adb pull $cfg_output_dir/$cfg_output &> /dev/null
871 fi
David Brazdil5cc343d2015-10-08 11:35:32 +0100872 "$checker" $checker_args "$cfg_output" "$tmp_dir" 2>&1
Calin Juravle3cf48772015-01-26 16:47:33 +0000873 checker_exit="$?"
874 if [ "$checker_exit" = "0" ]; then
875 good="yes"
876 fi
Alex Light91de25f2015-10-28 17:00:06 -0700877 err_echo "checker exit status: $checker_exit"
Calin Juravle3cf48772015-01-26 16:47:33 +0000878 else
879 good="yes"
880 fi
Brian Carlstrom700c8d32012-11-05 10:42:02 -0800881 fi
Calin Juravle3cf48772015-01-26 16:47:33 +0000882 echo "run exit status: $run_exit" 1>&2
Elliott Hughes7ab3a2a2012-06-18 16:34:20 -0700883 fi
jeffhao5d1ac922011-09-29 17:41:15 -0700884elif [ "$update_mode" = "yes" ]; then
David Brazdil4846d132015-01-15 19:07:08 +0000885 "./${build}" $build_args >"$build_output" 2>&1
jeffhao5d1ac922011-09-29 17:41:15 -0700886 build_exit="$?"
887 if [ "$build_exit" = '0' ]; then
Elliott Hughes2bfc6732012-11-27 20:40:51 -0800888 echo "${test_dir}: running..." 1>&2
jeffhao5d1ac922011-09-29 17:41:15 -0700889 "./${run}" $run_args "$@" >"$output" 2>&1
David Brazdil4846d132015-01-15 19:07:08 +0000890 if [ "$run_checker" = "yes" ]; then
Alexandre Rames5e2c8d32015-08-06 14:49:28 +0100891 if [ "$target_mode" = "yes" ]; then
892 adb pull $cfg_output_dir/$cfg_output &> /dev/null
893 fi
David Brazdil5cc343d2015-10-08 11:35:32 +0100894 "$checker" -q $checker_args "$cfg_output" "$tmp_dir" >> "$output" 2>&1
David Brazdil4846d132015-01-15 19:07:08 +0000895 fi
jeffhao5d1ac922011-09-29 17:41:15 -0700896 sed -e 's/[[:cntrl:]]$//g' < "$output" >"${td_expected}"
897 good="yes"
898 else
Alex Light91de25f2015-10-28 17:00:06 -0700899 cat "$build_output" 1>&${real_stderr} 1>&2
900 err_echo "build exit status: $build_exit"
jeffhao5d1ac922011-09-29 17:41:15 -0700901 fi
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700902elif [ "$build_only" = "yes" ]; then
903 good="yes"
David Brazdil4846d132015-01-15 19:07:08 +0000904 "./${build}" $build_args >"$build_output" 2>&1
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700905 build_exit="$?"
906 if [ "$build_exit" '!=' '0' ]; then
907 cp "$build_output" "$output"
908 echo "build exit status: $build_exit" >>"$output"
909 diff --strip-trailing-cr -q "$expected" "$output" >/dev/null
910 if [ "$?" '!=' "0" ]; then
911 good="no"
Alex Light91de25f2015-10-28 17:00:06 -0700912 err_echo "BUILD FAILED For ${TEST_NAME}"
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700913 fi
914 fi
Tsu Chiang Chuang379e2f52013-08-20 12:24:52 -0700915 # Clean up extraneous files that are not used by tests.
Tsu Chiang Chuang0160d992013-09-13 14:17:42 -0700916 find $tmp_dir -mindepth 1 ! -regex ".*/\(.*jar\|$output\|$expected\)" | xargs rm -rf
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700917 exit 0
jeffhao5d1ac922011-09-29 17:41:15 -0700918else
David Brazdil4846d132015-01-15 19:07:08 +0000919 "./${build}" $build_args >"$build_output" 2>&1
jeffhao5d1ac922011-09-29 17:41:15 -0700920 build_exit="$?"
921 if [ "$build_exit" = '0' ]; then
Elliott Hughes2bfc6732012-11-27 20:40:51 -0800922 echo "${test_dir}: running..." 1>&2
jeffhao5d1ac922011-09-29 17:41:15 -0700923 "./${run}" $run_args "$@" >"$output" 2>&1
Nicolas Geoffray1ed097d2014-11-13 15:15:39 +0000924 run_exit="$?"
925 if [ "$run_exit" != "0" ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700926 err_echo "run exit status: $run_exit"
Nicolas Geoffray1ed097d2014-11-13 15:15:39 +0000927 good_run="no"
David Brazdil4846d132015-01-15 19:07:08 +0000928 elif [ "$run_checker" = "yes" ]; then
Alexandre Rames5e2c8d32015-08-06 14:49:28 +0100929 if [ "$target_mode" = "yes" ]; then
930 adb pull $cfg_output_dir/$cfg_output &> /dev/null
931 fi
David Brazdil5cc343d2015-10-08 11:35:32 +0100932 "$checker" -q $checker_args "$cfg_output" "$tmp_dir" >> "$output" 2>&1
David Brazdil4846d132015-01-15 19:07:08 +0000933 checker_exit="$?"
934 if [ "$checker_exit" != "0" ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700935 err_echo "checker exit status: $checker_exit"
David Brazdil4846d132015-01-15 19:07:08 +0000936 good_run="no"
937 else
938 good_run="yes"
939 fi
Nicolas Geoffray1ed097d2014-11-13 15:15:39 +0000940 else
941 good_run="yes"
942 fi
jeffhao5d1ac922011-09-29 17:41:15 -0700943 else
Nicolas Geoffray1ed097d2014-11-13 15:15:39 +0000944 good_build="no"
jeffhao5d1ac922011-09-29 17:41:15 -0700945 cp "$build_output" "$output"
Andreas Gampef6930a82014-10-21 09:33:08 -0700946 echo "Failed to build in tmpdir=${tmp_dir} from oldwd=${oldwd} and cwd=`pwd`" >> "$output"
947 echo "Non-canonical tmpdir was ${noncanonical_tmp_dir}" >> "$output"
Ian Rogersd9ad27d2014-10-27 13:48:21 -0700948 echo "Args: ${args}" >> "$output"
Andreas Gampef6930a82014-10-21 09:33:08 -0700949 echo "build exit status: $build_exit" >> "$output"
Andreas Gampe5c114902014-10-27 17:03:58 -0700950 max_name_length=$(getconf NAME_MAX ${tmp_dir})
951 echo "Max filename (NAME_MAX): ${max_name_length}" >> "$output"
952 max_path_length=$(getconf PATH_MAX ${tmp_dir})
Andreas Gampe602fbcd2014-10-27 17:06:29 -0700953 echo "Max pathlength (PATH_MAX): ${max_path_length}" >> "$output"
jeffhao5d1ac922011-09-29 17:41:15 -0700954 fi
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700955 ./$check_cmd "$expected" "$output"
jeffhao5d1ac922011-09-29 17:41:15 -0700956 if [ "$?" = "0" ]; then
Nicolas Geoffray1ed097d2014-11-13 15:15:39 +0000957 if [ "$good_build" = "no" -o "$good_run" = "yes" ]; then
958 # output == expected
959 good="yes"
960 echo "${test_dir}: succeeded!" 1>&2
961 fi
jeffhao5d1ac922011-09-29 17:41:15 -0700962 fi
963fi
964
jeffhao5d1ac922011-09-29 17:41:15 -0700965(
Alex Lightbfac14a2014-07-30 09:41:21 -0700966 if [ "$good" != "yes" -a "$update_mode" != "yes" ]; then
jeffhao5d1ac922011-09-29 17:41:15 -0700967 echo "${test_dir}: FAILED!"
968 echo ' '
969 echo '#################### info'
970 cat "${td_info}" | sed 's/^/# /g'
971 echo '#################### diffs'
Hiroshi Yamauchid630fd62015-09-04 12:52:03 -0700972 diff --strip-trailing-cr -u "$expected" "$output" | tail -n 3000
jeffhao5d1ac922011-09-29 17:41:15 -0700973 echo '####################'
Hiroshi Yamauchi1d4184d2015-07-13 17:11:22 -0700974 if [ "$strace" = "yes" ]; then
975 echo '#################### strace output'
Hiroshi Yamauchid630fd62015-09-04 12:52:03 -0700976 tail -n 3000 "$tmp_dir/$strace_output"
Hiroshi Yamauchi1d4184d2015-07-13 17:11:22 -0700977 echo '####################'
978 fi
Andreas Gampee79ca192017-07-31 10:30:16 -0700979 if [ "x$target_mode" = "xno" -a "x$SANITIZE_HOST" = "xaddress" ]; then
980 # Run the stack script to symbolize any ASAN aborts on the host for SANITIZE_HOST. The
981 # tools used by the given ABI work for both x86 and x86-64.
982 echo "ABI: 'x86_64'" | cat - "$output" | $ANDROID_BUILD_TOP/development/scripts/stack | tail -n 3000
983 fi
jeffhao5d1ac922011-09-29 17:41:15 -0700984 echo ' '
985 fi
Alex Lightbfac14a2014-07-30 09:41:21 -0700986
Alex Light91de25f2015-10-28 17:00:06 -0700987) 2>&${real_stderr} 1>&2
Alex Lightbfac14a2014-07-30 09:41:21 -0700988
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -0700989# Attempt bisection only if the test failed.
990if [ "$bisection_search" = "yes" -a "$good" != "yes" ]; then
991 # Bisecting works by skipping different optimization passes which breaks checker assertions.
992 if [ "$run_checker" == "yes" ]; then
993 echo "${test_dir}: not bisecting, checker test." 1>&2
994 else
995 # Increase file size limit, bisection search can generate large logfiles.
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -0700996 echo "${test_dir}: bisecting..." 1>&2
997 cwd=`pwd`
998 maybe_device_mode=""
999 raw_cmd=""
1000 if [ "$target_mode" = "yes" ]; then
1001 # Produce cmdline.sh in $DEX_LOCATION. "$@" is passed as a runtime option
1002 # so that cmdline.sh forwards its arguments to dalvikvm. invoke-with is set
1003 # to exec in order to preserve pid when calling dalvikvm. This is required
1004 # for bisection search to correctly retrieve logs from device.
1005 "./${run}" $run_args --runtime-option '"$@"' --invoke-with exec --dry-run "$@" &> /dev/null
1006 adb shell chmod u+x "$DEX_LOCATION/cmdline.sh"
1007 maybe_device_mode="--device"
1008 raw_cmd="$DEX_LOCATION/cmdline.sh"
1009 else
1010 raw_cmd="$cwd/${run} --external-log-tags $run_args $@"
1011 fi
1012 $ANDROID_BUILD_TOP/art/tools/bisection_search/bisection_search.py \
1013 $maybe_device_mode \
1014 --raw-cmd="$raw_cmd" \
1015 --check-script="$cwd/check" \
1016 --expected-output="$cwd/expected.txt" \
Wojciech Staszkiewicz0c883832016-09-26 17:51:52 -07001017 --logfile="$cwd/bisection_log.txt" \
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -07001018 --timeout=300
1019 fi
1020fi
1021
Alex Lightbfac14a2014-07-30 09:41:21 -07001022# Clean up test files.
Igor Murashkin05f30e12015-06-10 15:57:17 -07001023if [ "$always_clean" = "yes" -o "$good" = "yes" ] && [ "$never_clean" = "no" ]; then
Alex Lightbfac14a2014-07-30 09:41:21 -07001024 cd "$oldwd"
1025 rm -rf "$tmp_dir"
1026 if [ "$target_mode" = "yes" -a "$build_exit" = "0" ]; then
1027 adb shell rm -rf $DEX_LOCATION
1028 fi
1029 if [ "$good" = "yes" ]; then
1030 exit 0
1031 fi
1032fi
1033
1034
1035(
1036 if [ "$always_clean" = "yes" ]; then
1037 echo "${TEST_NAME} files deleted from host "
1038 if [ "$target_mode" == "yes" ]; then
1039 echo "and from target"
1040 fi
1041 else
1042 echo "${TEST_NAME} files left in ${tmp_dir} on host"
1043 if [ "$target_mode" == "yes" ]; then
1044 echo "and in ${DEX_LOCATION} on target"
1045 fi
Brian Carlstrom105215d2012-06-14 12:50:44 -07001046 fi
1047
Alex Light91de25f2015-10-28 17:00:06 -07001048) 2>&${real_stderr} 1>&2
jeffhao5d1ac922011-09-29 17:41:15 -07001049
Alex Light6a870fa2016-05-31 16:36:19 -07001050if [ "$never_clean" = "yes" ] && [ "$good" = "yes" ]; then
1051 exit 0
1052else
1053 exit 1
1054fi